=== debian/changelog ===
rocksdb (5.17.2-3) unstable; urgency=medium

  * Backport fix for snprintf() buffer overflow.
  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 19 Dec 2018 17:01:38 +0000

rocksdb (5.17.2-2) experimental; urgency=medium

  * Backport upstream fix for db_bench_tool.cc FTBFS.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 09 Dec 2018 06:00:39 +0000

rocksdb (5.17.2-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from librocksdb5.15 to librocksdb5.17 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 22 Nov 2018 16:25:48 +0100

rocksdb (5.15.10-2) unstable; urgency=medium

  * Remove ppc64 from build architectures, upstream doesn't want to
    support it.
  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 21 Nov 2018 21:07:17 +0000

rocksdb (5.15.10-1) experimental; urgency=medium

  * New major upstream release.
  * Library transition from librocksdb5.14 to librocksdb5.15 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 18 Sep 2018 20:52:12 +0000

rocksdb (5.14.3-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.2.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 01 Sep 2018 17:57:29 +0000
